"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Logger = _interopRequireDefault(require("../Logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = _Logger.default.child({
  namespace: 'createGlobalAgentGlobal'
});

const KNOWN_PROPERTY_NAMES = ['bootstrapped', 'HTTP_PROXY', 'HTTPS_PROXY', 'NO_PROXY'];

const createGlobalAgentGlobal = () => {
  // eslint-disable-next-line fp/no-proxy
  return new Proxy({
    bootstrapped: false,
    HTTP_PROXY: '',
    HTTPS_PROXY: '',
    NO_PROXY: ''
  }, {
    set: (subject, name, value) => {
      if (!KNOWN_PROPERTY_NAMES.includes(name)) {
        throw new Error('Cannot set an unmapped property "' + name + '".');
      }

      subject[name] = value;
      log.info({
        change: {
          name,
          value
        },
        newConfiguration: subject
      }, 'configuration changed');
      return true;
    }
  });
};

var _default = createGlobalAgentGlobal;
exports.default = _default;
//# sourceMappingURL=createGlobalAgentGlobal.js.map